var STATUS_BAR = "status-bar", Positioner = Class.extend({
    init: function(logging, prefs, analytics) {
        this._logger = logging.getLogger("positioner"), this._prefs = prefs, this._analytics = analytics, this._displayed_addonbar = !1;
    },
    is_valid_position: function(win, toolbar, position) {
        var target = win.document.getElementById(toolbar);
        return target != null;
    },
    update_all_positions: function() {
        var mediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator), windows = mediator.getEnumerator("navigator:browser"), p = this._prefs.preference("toolbar"), toolbar = p.parent, position = p.position;
        while (windows.hasMoreElements()) this.update_position(windows.getNext(), toolbar, position);
    },
    update_position: function(win, toolbar, position) {
        var doc = win.document, p, addonbar = doc.getElementById("addon-bar");
        toolbar == "DEFAULT" && (toolbar = STATUS_BAR, addonbar && addonbar.collapsed && (addonbar.collapsed = !1, doc.persist(addonbar.id, "collapsed"), this._displayed_addonbar = !0), p = this._prefs.preference("toolbar"), p.parent = toolbar, this._prefs.preference("toolbar", p)), this.is_valid_position(win, toolbar, position) || (p = this._prefs.preference("toolbar"), p.parent = toolbar = PREFERENCES_DEFAULTS.toolbar.parent, p.position = position = PREFERENCES_DEFAULTS.toolbar.position, this._prefs.preference("toolbar", p));
        var ffbar = doc.getElementById("forecastfox-toolbar"), target = doc.getElementById(toolbar);
        ffbar.parentNode.removeChild(ffbar);
        var newbar;
        toolbar == STATUS_BAR ? ffbar.localName != "statusbarpanel" && (newbar = doc.createElement("statusbarpanel")) : ffbar.localName == "statusbarpanel" && (newbar = doc.createElement("hbox"));
        if (newbar) {
            newbar.setAttribute("id", ffbar.getAttribute("id"));
            while (ffbar.hasChildNodes()) newbar.appendChild(ffbar.firstChild);
        } else newbar = ffbar;
        newbar.setAttribute("context", "forecastfox-popup");
        var children = target.childNodes, placed = !1;
        for (var x = 0; x < children.length; x++) x == position && (target.insertBefore(newbar, children[x]), placed = !0);
        (position == "last" || !placed) && target.appendChild(newbar);
        var parent = target;
        while (parent) {
            if (parent == addonbar && addonbar.collapsed) {
                if (this._displayed_addonbar) break;
                addonbar.collapsed = !1, doc.persist(addonbar.id, "collapsed"), this._logger.debug("displaying the addonbar"), this._analytics.trackEvent("Operations", "Addonbar", "ForceVisible"), this._displayed_addonbar = !0;
                break;
            }
            parent = parent.parentNode;
        }
    }
});