var Forecastfox = {
    environment: "firefox",
    _iframes: {},
    services: function() {
        if ("services" in this._iframes) return this._iframes.services;
        var win = Components.classes["@mozilla.org/appshell/appShellService;1"].getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow, iframe = win.document.getElementById("forecastfox-services");
        return iframe || (iframe = win.document.createElement("iframe"), iframe.setAttribute("id", "forecastfox-services"), iframe.setAttribute("collapsed", "true"), iframe.setAttribute("src", "chrome://forecastfox/content/services.html"), win.document.documentElement.appendChild(iframe)), this._iframes.services = iframe.contentWindow, this._iframes.services;
    },
    url: function(path) {
        return "chrome://forecastfox/" + path;
    },
    customize: function(anchor) {
        var version = this.services().PREFERENCES_DEFAULTS.version;
        this.open("http://www.getforecastfox.com/customize/" + version + "/" + (anchor ? anchor : ""));
    },
    open: function(url, category, action, type) {
        var mediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator), browserEnumerator = mediator.getEnumerator("navigator:browser"), found = !1;
        while (!found && browserEnumerator.hasMoreElements()) {
            var browserWin = browserEnumerator.getNext(), tabbrowser = browserWin.gBrowser, numTabs = tabbrowser.browsers.length;
            for (var index = 0; index < numTabs; index++) {
                var currentBrowser = tabbrowser.getBrowserAtIndex(index);
                if (url == currentBrowser.currentURI.spec) {
                    tabbrowser.selectedTab = tabbrowser.tabContainer.childNodes[index], browserWin.focus(), found = !0;
                    break;
                }
            }
        }
        if (!found) {
            var win = this._getTopWindow(), browser = win.getBrowser();
            browser.loadOneTab(url, null, null, null, !1), win.focus();
        }
        var analytics = this.services().analytics;
        category && analytics.trackEvent(category, action, type, "HOUR");
    },
    api: function() {
        return this.services().forecastfox_api();
    },
    contextMenu: function(item) {
        var bgp = this.services();
        item == "community" ? this.open("http://www.getforecastfox.com/contribute/", "ContextMenu", "Click", "Community") : item == "homepage" ? this.open("http://www.getforecastfox.com/", "ContextMenu", "Click", "HomePage") : item == "accuweather" ? this.open("http://www.accuweather.com/?partner=forecastfox", "ContextMenu", "Click", "AccuWeather") : item == "share" ? this.open("http://staging.getforecastfox.com/share/", "ContextMenu", "Click", "Share") : item == "customize" ? (bgp.analytics.trackEvent("ContextMenu", "Click", "Customize"), this.customize()) : item == "troubleshooting" ? this.open("chrome://forecastfox/content/troubleshooting.html", "ContextMenu", "Click", "TroubleShooting") : item == "reload" ? (bgp.analytics.trackEvent("ContextMenu", "Click", "ReloadData"), bgp.locations.update_feed(bgp.locations.selected(), !0)) : item == "newLocation" && (bgp.analytics.trackEvent("ContextMenu", "Click", "NewLocation"), this.customize("#location"));
    },
    _getTopWindow: function() {
        var mediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator), win = mediator.getMostRecentWindow("navigator:browser");
        if (!win) {
            var chrome = "chrome://browser/content/browser.xul", flags = "chrome=yes,all=yes,dialog=no", args = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString), ww = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
            win = ww.openWindow(null, chrome, "_blank", flags, args), win.setTimeout(function() {
                win.focus();
            }, 0);
        }
        return win;
    }
};