var logging = {
    getLogger: function(l) {
        return logger;
    }
}, logger = {
    setLevel: function(level) {},
    isEnabledFor: function(level) {},
    debug: function(msg) {
        this.log(msg);
    },
    info: function(msg) {
        this.log(msg);
    },
    warn: function(msg) {
        this.log(msg);
    },
    error: function(msg) {
        this.log(msg);
    },
    critical: function(msg) {
        this.log(msg);
    },
    exception: function(msg, e) {
        this.log(msg), this.log(e);
    },
    log: function(level, msg, e) {
        "console" in window && console.log && console.log((new Date).getTime() / 1e3 + level);
    },
    addHandler: function(handler) {},
    removeHandler: function(handler) {}
}, observers;

observers = new OptionsObservers(logging);

var templator = new Templator(logging, document), i18n = new OptionsI18n, radio_group = function(selector) {
    $(selector).disableSelection(), $(selector).unbind("click"), $(selector).click(function() {
        $(selector).removeClass("selected"), $(this).addClass("selected");
    });
}, radio_multi_group = function(selector) {
    $(selector).disableSelection(), $(selector).unbind("click").addClass("multi").click(function(e) {
        if (e.ctrlKey || e.metaKey) {
            var selection = $(selector).filter(".selected").length + 1;
            $(this).addClass("selected"), $(this).attr("sindex", selection);
        } else $(selector).removeClass("selected"), $(selector).attr("sindex", ""), $(this).addClass("selected"), $(this).attr("sindex", "1");
    });
}, isMac;

$(function() {
    $("#location").corner("keep 8px"), observers.add("ui-content-script-loaded", function() {
        observers.notify("ui-get-locale-request", {}), observers.notify("ui-get-options-request", {}), observers.notify("ui-get-locations-request", {});
    }), observers.add("ui-restore-defaults-results", function() {
        window.location.reload();
    }), Forecastfox.environment == "chrome" && observers.notify("ui-content-script-loaded"), observers.notify("ui-set-options-request", {
        showoptions: !1
    }), $(window).unload(function() {
        observers.notify("ui-set-options-request", {
            firefoxmigration: !1
        });
    }), setTimeout(function() {
        typeof _loadUserVoice != "undefined" && _loadUserVoice();
    }, 30), isMac = $.client.os == "Mac", $(".pc").toggleClass("hidden", isMac), $(".mac").toggleClass("hidden", !isMac);
});

function reset_all_settings() {
    confirm(i18n.data("options.restore.confirm")) && observers.notify("ui-restore-defaults-request", {});
}

$(window).unload(function() {
    observers.notify("ui-options-close", {});
});